\chapter{Introduction}
\section{General}
When we query some data in a database, we want that query performance to be as fast as possible. Therefore, indexes can make a huge difference. Indexes are special lookup tables that the database search engine can use to speed up the data retrieval process. An index in a database is very similar to an index in the back of a book \cite{indexes}. With indexes, we can speed up the SQL 'SELECT' queries and the 'WHERE' clauses. However, as a drawback, we lose some performance in inserting and updating the tables because the indexes need to be adjusted beforehand. This problem is known as the Index Selection Problem (ISP) \cite{isp}.\\
\newline
With the technology evolving every day, there exist some extension/libraries that allow us to automate the database index query optimization, one of those which we will talk about. What automation means in this case, is that the extension that we choose to automate our indexes, will analyze our database logs, examine them and then generate some suggestions for handy indexes related to our database tables.

\section{Query optimization with indexes}
The correct indexes depend on the queries we expect to receive. If we know which queries the database has to handle, we can logically create the handiest indexes for those specific tables.
\\
One of the most popular ways to optimize database queries is using indexes.\\\\
Let's say we have a very large table with a lot of columns and information. In order to retrieve this kind of information, the computer will have to run through every row of the table until it finds the desired record, and if that record is at the very end of a table, well, that query would take a long time to run. This is when indexing comes in hand.\\\\
On the other hand, if, let's say we have a table full of names that are not sorted at all, we could create an index that stores the name column inside of it in an alphabetically sorted way. When this happens, and we execute the same query to retrieve a record that is by the end of the table, we would find that record in much fewer steps (by jumping on the half of the remaining rows). So, instead of having another table which holds all the record sorted in an alphabetical way, we could create an index which does that for us, and it would not require the extra storage space and maintenance that a table requires.\\
This doesn't necessarily mean that we should use indexes everywhere. If we have a database that is constantly receiving writes, then the indexes become pretty much unusable because every time a write is made to the database, the indexes are unusable until they have been updated as well. Therefore, indexing is more useful in data warehouses that get the data on a scheduled basis. This does not always apply, though.
\section{Dexter}
The Postgres extension Dexter \cite{Dexter} is a smart extension that tells us which index we should add to the table, based on the queries that we send to the database. It can be used for analyzing queries, debugging them and last but not least, generating automatic indexes that we can easily add to the tables to speed up the querying performance.
\\\\
Dexter has two phases that it goes through in order to index a database. \cite{IntroductionDexter}
\begin{enumerate}
    \item Collect queries
    \item Generate indexes
\end{enumerate}

\subsection{Collect Queries}
Dexter can collect queries either by streaming log files from Postgres, by passing a single statement, by passing one or multiple files or by running in the background of Postgres. It takes the collected queries and uses a fingerprinting to group queries. To improve this process, we can set some options. For example, we can set a minimum of calls which a query need to be executed to be considered for indexing. Or we can set a minimum of execution time for which a query has to run in total to get into account. With these options, we can avoid over-indexing. A requirement for this step is the extension pg\_query \cite{pgquery}. pg\_query is written in ruby and allows to normalize, parse and fingerprint a query.

\subsection{Generate indexes}
After we have collected queries, we need to generate indexes to speed up the next database queries. This step is done with hypothetical indexes. Such indexes are not really existing and need no additional calculation time nor resources. But they are needed to analyze the total time of a query if it had such an index. In fact, these virtual indexes are very useful before generating an index. The PostgreSQL extension to add support for these hypothetical indexes is called HypoPG \cite{HypoPG}.\\
HypoPG is a PostgreSQL extension that adds support for hypothetical objects. And by hypothetical objects, in this case, we are talking about hypothetical indexes.\\
A hypothetical or virtual index is an index that doesn't really exist and thus doesn’t cost CPU, disk or any resource to create. They’re useful to know if specific indexes can increase performance for problematic queries since you can know if PostgreSQL will use these indexes or not without having to spend resources to create them. \cite{HypoPGHypotheticalObjects}\\
HypoPG is compatible with PostgreSQL 9.2 and above and is required for  Dexter. More information about hypothetical indexes can be found here: \\ \url{https://rjuju.github.io/postgresql/2015/07/02/how-about-hypothetical-indexes.html}.\\

Dexter does the index generation in the following steps: \cite{IntroductionDexter}
\begin{enumerate}
    \item Filter out queries on system tables and other databases
    \item Analyze tables for up-to-date planner statistics if they haven’t been analyzed recently
    \item Get the initial cost of queries
    \item Create hypothetical indexes on columns that aren’t already indexed
    \item Get costs again and see if any hypothetical indexes were used
\end{enumerate}

Then it recommends the used hypothetical indexes which increase the performance to the user. These indexes can then be added manually or if wanted, can also be created automatically if a 'create' flag has been set.

\section{Result}
With this process, we can optimize our database and improve the performance drastically for the future. Of course, we have some drawbacks like the slightly more time-consuming task of changing data and the disk space needed for the indexes. Dexter has a solution to handle write-heavy tables by excluding them manually. And disk space should become less and less of a problem nowadays. So it's time to make forgotten indexes a problem of the past. \cite{IntroductionDexter}.